from v6d2ctx.context import *
from v6d3music.core.real_url import *
from v6d3music.core.ytaservicing import *
from v6d3music.core.ytaudio import *
from v6d3music.utils.argctx import *

__all__ = ('create_ytaudio',)


async def _create_ytaudio(
    servicing: YTAServicing, bound: BoundCtx
) -> YTAudio:
    return YTAudio(
        servicing,
        await real_url(servicing.caching, bound.url, False, bound.tor),
        bound.url,
        bound.description,
        bound.options,
        bound.member,
        bound.already_read,
        bound.tor
    )


async def create_ytaudio(
        servicing: YTAServicing, ctx: Context, it: InfoCtx
) -> YTAudio:
    bound = it.bind(ctx)
    return await _create_ytaudio(servicing, bound)
